# jQuery based AJAX Form
# Author: Sanjiv Singh <SinghSanjivK@gmail.com>
# License: MIT

from tw.api import Widget, JSLink, CSSLink, JSSource, js_function, js_callback
from tw.forms import TableForm
from tw.jquery.base import *

jquery_form_js    = JSLink(modname=__name__, filename='static/javascript/jquery.form.js', javascript=[])
jQuery= js_function('$')

class AjaxForm(TableForm):

    params =   ["id", "target", "beforeSubmit", "action"
		"success", "type", "dataType",
		"clearForm", "resetForm", "timeout"]

    target_doc = ""
    beforeSubmit_doc = ""
    action_doc = ""
    success_doc = ""
    type_doc = ""
    dataType_doc = ""
    clearForm_doc = ""
    resetForm_doc = ""
    timeout_doc = ""

    target = "output"
    beforeSubmit = ""
    action = ""
    success = ""
    type = "POST"
    dataType = ""
    clearForm = True
    resetForm = True
    timeout = 5000

    template="genshi:tw.jquery.templates.activeform"
    javascript = [jquery_js, jquery_form_js]
    include_dynamic_js_calls = True

    def update_params(self, d):
        super(AjaxForm, self).update_params(d)
        if not getattr(d,"id",None):
            raise ValueError, "AjaxForm is supposed to have id"

        options = dict(target=('#%s' % self.target),
			beforeSubmit=self.beforeSubmit,
			success=self.success,
			url=self.action,
			type=self.type,
			dataType=self.dataType,
			clearForm=self.clearForm,
			resetForm=self.resetForm,
			timeout=self.timeout)

        call = js_function('$("#%s").ajaxForm' % d.id)(options)
        self.add_call(call)

