from tw.api import Widget, JSLink, CSSLink, js_function, js_callback

from tw.jquery.base import *
from tw.forms import FormField
jquery_autocomplete_js    = JSLink(modname=__name__, filename='static/javascript/jquery.autocomplete.js', javascript=[jquery_dimensions_js,jquery_bgiframe_js])
jQuery= js_function('$')
jquery_autocomplete_css=CSSLink(modname=__name__, filename='static/css/jquery.autocomplete.css')

class AutoCompleteField(FormField):
        params = ["minChars","completionURL", "fetchJSON","selectFirst"]
        minChars__doc="minChars The minimum number of characters a user has to type before the autocompleter activates."
        selectFirst__doc="If this is set to true, the first autocomplete value will be automatically selected on tab/return, even if it has not been handpicked by keyboard or mouse action. If there is a handpicked (highlighted) result, that result will take precedence."
        completionURL__doc=""
        fetchJSON_doc=""
        minChars=3
        fetchJSON=False
        selectFirst=False
        include_dynamic_js_calls = True
        template="genshi:tw.jquery.templates.autocompletefield"
        javascript=[jquery_autocomplete_js]
        css=[jquery_autocomplete_css]
        def update_params(self, d):
            super(AutoCompleteField, self).update_params(d)
            if not getattr(d,"id",None):
                raise ValueError, "AutocompleteField is supposed to have id"
            
            if (self.fetchJSON):
                json_callback = js_callback('function(data) {$("#%s").autocomplete(data["data"]);}' % d.id)
                call = js_function('$.getJSON')(self.completionURL, json_callback)
                self.add_call(call)
            else:
                self.add_call(
                jQuery('#%s' % d.id).autocomplete(self.completionURL,dict(minChars=self.minChars,selectFirst=self.selectFirst))
                )
