from tw.api import Widget, JSLink, CSSLink, js_function
from tw.forms.fields import TextField

__all__ = [	"datepicker_js", 
			"datepicker_css", 
			'UIDatePicker',
			'datepicker_es_js',
			'UIDatePicker_ES']

# JS Links

datepicker_js = JSLink(	modname=__name__, 
						filename='static/javascript/ui-datepicker/ui.datepicker.js', 
						javascript=[])
datepicker_es_js = JSLink(	modname=__name__, 
						filename='static/javascript/ui-datepicker/ui.datepicker-es.js', 
						javascript=[])

# CSS Links

datepicker_css   = CSSLink(	modname=__name__, 
							filename='static/css/ui.datepicker.css')

class UIDatePicker(TextField):
	javascript = [datepicker_js]
	css = [datepicker_css]
	
	def update_params(self, d):
		super(UIDatePicker, self).update_params(d)
		if not getattr(d,"id",None):
			raise ValueError, "DatePicker is supposed to have id"
			
		call = js_function("$('#%s').datepicker" % d.id)()
		self.add_call(call)

class UIDatePicker_ES(UIDatePicker):
	javascript = [datepicker_es_js,datepicker_js]

# JQuery UI Date Picker Plugin implemented by Laureano Arcanio 2008
