from tw.api import Widget, JSLink, CSSLink,js_function
from tw.forms.fields import TableForm

__all__ = [	"JQValidate", 
			"JQValidatePacked", 
			'validate_js', 
			'validate_js_pack', 
			'validate_css', 
			'JQTableForm',
			'JQTableForm_ES']

# JS Links

validate_js = JSLink(	modname=__name__, 
						filename='static/javascript/validate/jquery.validate.js', 
						javascript=[])

validate_js_pack = JSLink(	modname=__name__, 
							filename='static/javascript/validate/jquery.validate.pack.js',
							javascript=[])

validate_js_min = JSLink(	modname=__name__, 
							filename='static/javascript/validate/jquery.validate.min.js',
							javascript=[])
							
validate_es_js = JSLink(	modname=__name__, 
							filename='static/javascript/validate/localization/messages_es.js',
							javascript=[])
							
# CSS Links

validate_css   = CSSLink(	modname=__name__, 
							filename='static/css/validation_form.css')

class JQValidate(Widget):
	javascript = [validate_js]
	css = [validate_css]

class JQValidatePacked(Widget):
	javascript = [validate_js_min]
	css = [validate_css]
		
class JQTableForm(TableForm):
	javascript = [validate_js]
	css = [validate_css]
	def update_params(self, d):
		super(JQTableForm, self).update_params(d)
		if not getattr(d,"id",None):
			raise ValueError, "JQTableForm is supposed to have id"
		call = js_function("$('#%s').validate" % d.id)()
		self.add_call(call)
		self.css.append(validate_css)
		
class JQTableForm_ES(JQTableForm):
	javascript = [validate_js, validate_es_js]
	
# JQuery Validate Plugin implemented by Laureano Arcanio 2008
